<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    /** @use HasFactory<\Database\Factories\UserFactory> */
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var list<string>
     */
    protected $fillable = [
        'name',
        'email',
        'email_verified_at',
        'password',
        'remember_token',
        'usergroup_id',
        'created_at',
        'updated_at',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var list<string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * Get the attributes that should be cast.
     *
     * @return array<string, string>
     */
    protected function casts(): array
    {
        return [
            'email_verified_at' => 'datetime',
            'password' => 'hashed',
        ];
    }

    public $timestamps = false;

    // Relation avec UserGroup
    public function usergroup()
    {
        return $this->belongsTo(Usergroup::class, 'usergroup_id', 'id');
    }

    // Relation avec ResponsableProgrammes
    public function responsableProgrammes()
    {
        return $this->hasMany(ResponsableProgramme::class, 'user_id', 'id');
    }
	
	public function responsablestructures()
    {
        return $this->hasMany(ResponsableStructure::class, 'user_id', 'id');
    }
	
	public function pointfocaux()
    {
        return $this->hasMany(Pointfocal::class, 'user_id', 'id');
    }
	
	public function isSuperAdmin()
	{
		return $this->usergroup_id == 2;
	}

}
